import es, os, gamethread, playerlib


# Mani Clients Reader ver 3.0 by Punisher(R)
# Reading admins by steamID, IP and Password.
# It support all mani methots to add admins. Like it might have names,steamid,ip more than 1 for each admin.
'''
So how to use it? I'll show you:
Here is an example:
'''

#import clients_reader as ma
#
#def load():
#	ma.get_clients()
#
#def player_activate(event_var):
#	if ma.isAdmin(event_var['userid']) > 0:
#		es.mag('Admin Has joined the game')

'''
Other available functions:

ma.get_clients()
reload clients.txt

ma.isAdmin(userid):
0 - not n admin
1 - admin by steam
2 - admin by ip
3 - admin bu nick+password

ma.hasFlag(userid, flag):
-1 - not an admin
0 - do not have flag
1 - have flag in admin group
2 - have flag in immune group

ma.hasGroup(userid, group):
-1 - not an admin
0 - do not have flag
1 - have admin group
2 - have immune group

ma.AdminName(userid):
0 - not an admin
list of names

ma.AdminFlags(userid):
0 - not an admin
list of flags

ma.ImmuneFlags(userid):
0 - not an admin
list of flags

ma.AdminImmuneGroups(userid):
0 - not an admin
list of immune groups

ma.AdminAdminGroups(userid):
0 - not an admin
list of admin groups
'''
status = 0
reloaded = 0

class FileError(Exception):
    pass

def get_clients():
	global admin, status, reloaded, clients
	if reloaded == 0:
		reloaded = 1
		gamethread.delayed(3, stop_reload)
		if status == 1:
			admin.clear()
		if status == 0:
			admin = {}
			status = 1
		clientsPath = str(es.ServerVar('eventscripts_gamedir'))+'/cfg/mani_admin_plugin/clients.txt'
		if not os.path.isfile(clientsPath):
			raise FileError("Couldn't load clients.txt: No such file")
		file = open(clientsPath, 'r')
		a=0
		type = 0
		b=0
		c=1
		clients=0
		ip_list=[]
		steam_list=[]
		nick_list=[]
		name_list=[]
		password=""
		immune_flags = []
		admin_flags = []
		admin_groups = []
		immune_groups = []
		group_name = ""
		group_flags = []
		flag = ""
		for line in file:
			d=0
			while (line[d] == " " or line[d] == "	"):
				d+=1
			if ((len(line) > d+1) and (line[d] != "/" and line[d+1] != "//")):
				n=0
				if line.find('"players"') != -1:
					type = 1
				elif type == 1:
					if line.find('{') != -1:
						a+=1
					elif line.find('}')  != -1:
						if a==2:
							clients+=1
							admin[clients] = {'name':[], 'steam':[], 'ip':[], 'nick':[],'password':None, 'admin_flags':[] , 'immune_flags':[], 'admin_groups':[], 'immune_groups':[]}
							if password != "":
								admin[clients]['password'] = password
							while len(ip_list)>0:
								admin[clients]['ip'].append(ip_list[0])
								ip_list.remove(ip_list[0])
							while len(steam_list)>0:
								admin[clients]['steam'].append(steam_list[0])
								steam_list.remove(steam_list[0])
							while len(nick_list)>0:
								admin[clients]['nick'].append(nick_list[0])
								nick_list.remove(nick_list[0])
							while len(name_list)>0:
								admin[clients]['name'].append(name_list[0])
								name_list.remove(name_list[0])
							while len(admin_flags)>0:
								admin[clients]['admin_flags'].append(admin_flags[0])
								admin_flags.remove(admin_flags[0])
							while len(immune_flags)>0:
								admin[clients]['immune_flags'].append(immune_flags[0])
								immune_flags.remove(immune_flags[0])
							while len(admin_groups)>0:
								admin[clients]['admin_groups'].append(admin_groups[0])
								admin_groups.remove(admin_groups[0])
							while len(immune_groups)>0:
								admin[clients]['immune_groups'].append(immune_groups[0])
								immune_groups.remove(immune_groups[0])
							password = ""
						a-=1
						if b>0:
							b=0
							c=1
						if a==0:
							type = 2
							b=0
					elif a==2:
						if line.find('"name"') != -1:
							name = ""
							n=line.find('"name"')+6
							while (line[n] != '"' and n<len(line)-1):
								n+=1
							if n==len(line)-1:
								b=3
							else:
								n+=1
								while (line[n] != '"' and n<len(line)-1):
									name += str(line[n])
									n+=1
								name_list.append(name)
						if line.find('"nick"') != -1:
							nick = ""
							n=line.find('"nick"')+6
							while (line[n] != '"' and n<len(line)-1):
								n+=1
							if n==len(line)-1:
								b=6
							else:
								n+=1
								while (line[n] != '"' and n<len(line)-1):
									nick += str(line[n])
									n+=1
								nick_list.append(nick)
						if line.find('"steam"') != -1:
							steam = ""
							n=line.find('"steam"')+7
							while (line[n] != '"' and n<len(line)-1):
								n+=1
							if n==len(line)-1:
								b=4
							else:
								n+=1
								while (line[n] != '"' and n<len(line)-1):
									steam += line[n]
									n+=1
								steam_list.append(steam)
						if line.find('"ip"') != -1:
							ip = ""
							n=line.find('"ip"')+4
							while (line[n] != '"' and n<len(line)-1):
								n+=1
							if n==len(line)-1:
								b=5
							else:
								n+=1
								while (line[n] != '"' and n<len(line)-1):
									ip += line[n]
									n+=1
								ip_list.append(ip)
						elif line.find('"password"') != -1:
							n=line.find('"password"')+10
							while (line[n] != '"' and n<len(line)-1):
								n+=1
							n+=1
							while (line[n] != '"' and n<len(line)-1):
								password += str(line[n])
								n+=1
						elif line.find('"flags"') != -1:
							b=1
						elif line.find('"groups"') != -1:
							b=2
					elif a==3:
						if b==1:
							if line.find('"Immunity"') != -1:
								n=line.find('"Immunity"')+10
								while (line[n] != '"' and n<len(line)-1):
									n+=1
								n+=1
								while (line[n] != '"' and n<len(line)-1):
									if line[n] not in [' ', '	']:
										immune_flags.append(line[n])
									n+=1
							elif line.find('"Admin"') != -1:
								n=line.find('"Admin"')+7
								while (line[n] != '"' and n<len(line)-1):
									n+=1
								n+=1
								while (line[n] != '"' and n<len(line)-1-1):
									if line[n] not in [' ', '	']:
										admin_flags.append(line[n])
									n+=1
						elif b==2:
							if line.find('"Immunity"') != -1:
								n=line.find('"Immunity"')+10
								while (line[n] != '"' and n<len(line)-1):
									n+=1
								n+=1
								while (line[n] != '"' and n<len(line)-1):
									flag+=line[n]
									n+=1
								immune_groups.append(flag)
								flag = ""
							elif line.find('"Admin"') != -1:
								n=line.find('"Admin"')+7
								while (line[n] != '"' and n<len(line)-1):
									n+=1
								n+=1
								while (line[n] != '"' and n<len(line)-1):
									flag+=line[n]
									n+=1
								admin_groups.append(flag)
								flag = ""
						elif b==3:
							if line.find('"name%s"'%c) != -1:
								name = ""
								n=line.find('"name%s"'%c)+len('"name%s"'%c)
								while (line[n] != '"' and n<len(line)-1):
									n+=1
								if n != len(line)-1:
									n+=1
									while (line[n] != '"' and n<len(line)-1):
										name+=line[n]
										n+=1
									name_list.append(name)
								c+=1
							else:
								c=1
						elif b==4:
							if line.find('"steam%s"'%c) != -1:
								steam = ""
								n=line.find('"steam%s"'%c)+len('"steam%s"'%c)
								while (line[n] != '"' and n<len(line)-1):
									n+=1
								if n != len(line)-1:
									n+=1
									while (line[n] != '"' and n<len(line)-1):
										steam+=line[n]
										n+=1
									steam_list.append(steam)
								c+=1
							else:
								c=1
						elif b==5:
							if line.find('"ip%s"'%c) != -1:
								ip = ""
								n=line.find('"ip%s"'%c)+len('"ip%s"'%c)
								while (line[n] != '"' and n<len(line)-1):
									n+=1
								if n != len(line)-1:
									n+=1
									while (line[n] != '"' and n<len(line)-1):
										ip+=line[n]
										n+=1
									ip_list.append(ip)
								c+=1
							else:
								c=1
						elif b==6:
							if line.find('"nick%s"'%c) != -1:
								nick = ""
								n=line.find('"nick%s"'%c)+len('"nick%s"'%c)
								while (line[n] != '"' and n<len(line)-1):
									n+=1
								if n != len(line)-1:
									n+=1
									while (line[n] != '"' and n<len(line)-1):
										nick+=line[n]
										n+=1
									nick_list.append(nick)
								c+=1
							else:
								c=1
				elif type == 2:
					if line.find('{') != -1:
						a+=1
					elif line.find('}') != -1:
						a-=1
						if b>0:
							b=0
					elif a==1:
						if line.find('"Admin"') != -1:
							b=1
						elif line.find('"Immunity"') != -1:
							b=2
					elif a==2:
						if line.find('"') != -1:
							n=line.find('"')+1
							while line[n] != '"':
								group_name += line[n]
								n+=1
							n+=1
							while line[n] != '"':
								n+=1
							n+=1
							while line[n] != '"':
								if line[n] not in [' ', '	']:
									flag+=line[n]
								else:
									group_flags.append(flag)
									flag = ""
								n+=1
							while len(group_flags)>0:
								for client in admin:
									for gr in admin[client]['admin_groups']:
										if gr == group_name:
											if group_flags[0] not in admin[client]['admin_flags']:
												admin[client]['admin_flags'].append(group_flags[0])
									for gr in admin[client]['immune_groups']:
										if gr == group_name:
											if group_flags[0] not in admin[client]['immune_flags']:
												admin[client]['immune_flags'].append(group_flags[0])
								group_flags.remove(group_flags[0])
							group_name = ""
		file.close()
def stop_reload():
	global reloaded
	reloaded = 0
def isAdmin(userid):
	ip,port = playerlib.getPlayer(userid).address.split(':')
	for clients in admin:
		if es.getplayersteamid(userid) in admin[clients]['steam']:
			return 1
		elif ip in admin[clients]['ip']:
			return 2
		elif es.getplayername(userid) in admin[clients]['nick']:
			if admin[clients]['password'] != None and es.getclientvar(userid, '_password') == admin[clients]['password']:
				return 3
	return 0

def hasFlag(userid, flag):
	ip,port = playerlib.getPlayer(userid).address.split(':')
	for clients in admin:
		if es.getplayersteamid(userid) in admin[clients]['steam']:
			if flag in admin[clients]['admin_flags']:
				return 1
			elif flag in admin[clients]['immune_flags']:
				return 2
			return 0
		elif ip in admin[clients]['ip']:
			if flag in admin[clients]['admin_flags']:
				return 1
			elif flag in admin[clients]['immune_flags']:
				return 2
			return 0
		elif es.getplayername(userid) in admin[clients]['nick']:
			if es.getclientvar('_password') == admin[clients]['password'] and admin[clients]['password'] != None:
				if flag in admin[clients]['admin_flags']:
					return 1
				elif flag in admin[clients]['immune_flags']:
					return 2
			return 0
	return -1
def hasGroup(userid, group):
	ip,port = playerlib.getPlayer(userid).address.split(':')
	for clients in admin:
		if es.getplayersteamid(userid) in admin[clients]['steam']:
			if group in admin[clients]['admin_groups']:
				return 1
			elif group in admin[clients]['immune_groups']:
				return 2
			return 0
		elif ip in admin[clients]['ip']:
			if group in admin[clients]['admin_groups']:
				return 1
			elif group in admin[clients]['immune_groups']:
				return 2
			return 0
		elif es.getplayername(userid) in admin[clients]['nick']:
			if es.getclientvar('_password') == admin[clients]['password'] and admin[clients]['password'] != None:
				if group in admin[clients]['admin_groups']:
					return 1
				elif group in admin[clients]['immune_groups']:
					return 2
			return 0
	return -1

def AdminName(userid):
	ip,port = playerlib.getPlayer(userid).address.split(':')
	for clients in admin:
		if es.getplayersteamid(userid) in admin[clients]['steam']:
			return (admin[clients]['name'])
		elif ip in admin[clients]['ip']:
			return (admin[clients]['name'])
		elif es.getplayername(userid) in admin[clients]['nick']:
			if es.getclientvar('_password') == admin[clients]['password'] and admin[clients]['password'] != None:
				return (admin[clients]['name'])
	return 0

def AdminFlags(userid):
	ip,port = playerlib.getPlayer(userid).address.split(':')
	for clients in admin:
		if es.getplayersteamid(userid) in admin[clients]['steam']:
			return (admin[clients]['admin_flags'])
		elif ip in admin[clients]['ip']:
			return (admin[clients]['admin_flags'])
		elif es.getplayername(userid) in admin[clients]['nick']:
			if es.getclientvar('_password') == admin[clients]['password'] and admin[clients]['password'] != None:
				return (admin[clients]['admin_flags'])
	return 0

def ImmuneFlags(userid):
	ip,port = playerlib.getPlayer(userid).address.split(':')
	for clients in admin:
		if es.getplayersteamid(userid) in admin[clients]['steam']:
			return (admin[clients]['immune_flags'])
		elif ip in admin[clients]['ip']:
			return (admin[clients]['immune_flags'])
		elif es.getplayername(userid) in admin[clients]['nick']:
			if es.getclientvar('_password') == admin[clients]['password'] and admin[clients]['password'] != None:
				return (admin[clients]['immune_flags'])
	return 0

def AdminImmuneGroups(userid):
	ip,port = playerlib.getPlayer(userid).address.split(':')
	for clients in admin:
		if es.getplayersteamid(userid) in admin[clients]['steam']:
			return (admin[clients]['immune_groups'])
		elif ip in admin[clients]['ip']:
			return (admin[clients]['immune_groups'])
		elif es.getplayername(userid) in admin[clients]['nick']:
			if es.getclientvar('_password') == admin[clients]['password'] and admin[clients]['password'] != None:
				return (admin[clients]['immune_groups'])
	return 0

def AdminAdminGroups(userid):
	ip,port = playerlib.getPlayer(userid).address.split(':')
	for clients in admin:
		if es.getplayersteamid(userid) in admin[clients]['steam']:
			return (admin[clients]['admin_groups'])
		elif ip in admin[clients]['ip']:
			return (admin[clients]['admin_groups'])
		elif es.getplayername(userid) in admin[clients]['nick']:
			if es.getclientvar('_password') == admin[clients]['password'] and admin[clients]['password'] != None:
				return (admin[clients]['admin_groups'])
	return 0